unit RS232Scaner;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TScanerForm = class(TForm)
    PortBox: TGroupBox;
    PortChoice: TComboBox;
    RegistersGroupBox: TGroupBox;
    Offset1: TLabel;
    Offset2: TLabel;
    Offset3: TLabel;
    Offset4: TLabel;
    Offset5: TLabel;
    Offset6: TLabel;
    Bevel1: TBevel;
    LinksBox: TGroupBox;
    CTSlink: TLabel;
    StaticText1: TStaticText;
    Bevel2: TBevel;
    DSRlink: TLabel;
    DCDlink: TLabel;
    TxDlink: TLabel;
    RTSlink: TLabel;
    DTRlink: TLabel;
    RIlink: TLabel;
    StaticText2: TStaticText;
    Bevel3: TBevel;
    StartStopBtn: TBitBtn;
    ExitBtn: TBitBtn;
    RefreshTimer: TTimer;
    StoreAllBtn: TBitBtn;
    OfsStr1: TLabel;
    OfsStr2: TLabel;
    OfsStr3: TLabel;
    OfsStr4: TLabel;
    OfsStr5: TLabel;
    OfsStr6: TLabel;
    procedure ExitBtnClick(Sender: TObject);
    procedure StartStopBtnClick(Sender: TObject);
    procedure PortChoiceChange(Sender: TObject);
    procedure RefreshTimerTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure StoreAllBtnClick(Sender: TObject);
  private
    { Private declarations }
    BA: word;
    StartStop: bool;
  public
    { Public declarations }
  end;

var
  ScanerForm: TScanerForm;

implementation

uses RS232;

{$R *.DFM}

procedure TScanerForm.ExitBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TScanerForm.StartStopBtnClick(Sender: TObject);
begin
  StartStop:= not StartStop;
  case StartStop of
    true:  StartStopBtn.Caption:= 'STOP';
    false: StartStopBtn.Caption:= 'START';
  end;
  RefreshTimer.Enabled:= StartStop;
end;

procedure TScanerForm.PortChoiceChange(Sender: TObject);
begin
  If PortChoice.Text= 'port COM1' then BA:= $3F8;
  If PortChoice.Text= 'port COM2' then BA:= $2F8;
  If PortChoice.Text= 'port COM3' then BA:= $3E8;
  If PortChoice.Text= 'port COM4' then BA:= $2E8;
end;

procedure TScanerForm.RefreshTimerTimer(Sender: TObject);
begin
  { Output }
  case Scan_TxD(BA) of
    true:  TxDlink.Color:= clRed;
    false: TxDlink.Color:= clBtnFace;
  end;
  case Scan_RTS(BA) of
    true:  RTSlink.Color:= clRed;
    false: RTSlink.Color:= clBtnFace;
  end;
  case Scan_DTR(BA) of
    true:  DTRlink.Color:= clRed;
    false: DTRlink.Color:= clBtnFace;
  end;
  { Input }
  case Scan_CTS(BA) of
    true:  CTSlink.Color:= clRed;
    false: CTSlink.Color:= clBtnFace;
  end;
  case Scan_DSR(BA) of
    true:  DSRlink.Color:= clRed;
    false: DSRlink.Color:= clBtnFace;
  end;
  case Scan_DCD(BA) of
    true:  DCDlink.Color:= clRed;
    false: DCDlink.Color:= clBtnFace;
  end;
  case Scan_RI(BA) of
    true:  RIlink.Color:= clRed;
    false: RIlink.Color:= clBtnFace;
  end;
  Offset1.Caption:= 'IntAct   : '+ IntToHex(ReadPort(BA+1), 2)+ 'H';
  Offset2.Caption:= 'IntIndfy : '+ IntToHex(ReadPort(BA+2), 2)+ 'H';
  Offset3.Caption:= 'LnkCtrl  : '+ IntToHex(ReadPort(BA+3), 2)+ 'H';
  Offset4.Caption:= 'MdmCtrl  : '+ IntToHex(ReadPort(BA+4), 2)+ 'H';
  Offset5.Caption:= 'LnkStatus: '+ IntToHex(ReadPort(BA+5), 2)+ 'H';
  Offset6.Caption:= 'MdmStatus: '+ IntToHex(ReadPort(BA+6), 2)+ 'H';
end;

procedure TScanerForm.FormCreate(Sender: TObject);
begin
  BA:= $2F8;
  StartStop:= false;
end;

procedure TScanerForm.StoreAllBtnClick(Sender: TObject);
begin
  OfsStr1.Caption:= Copy(Offset1.Caption, Pos(':',Offset1.Caption)+2, 3);
  OfsStr2.Caption:= Copy(Offset2.Caption, Pos(':',Offset2.Caption)+2, 3);
  OfsStr3.Caption:= Copy(Offset3.Caption, Pos(':',Offset3.Caption)+2, 3);
  OfsStr4.Caption:= Copy(Offset4.Caption, Pos(':',Offset4.Caption)+2, 3);
  OfsStr5.Caption:= Copy(Offset5.Caption, Pos(':',Offset5.Caption)+2, 3);
  OfsStr6.Caption:= Copy(Offset6.Caption, Pos(':',Offset6.Caption)+2, 3);
end;

end.
